<template>
  <div class="dashboard-page-container pb-5">
    <h1 class="page-title">Withdraw</h1>
    <div class="mt-4">
      <div class="row">
        <div class="col-sm-12 col-md-10">
          <div class="card card-setting">
            <div class="row justify-content-between align-items-center">
              <div ref="content" class="col-sm-12 col-md-4">
                <div class="group">
                  <p class="text-muted m-0">Agent Acount Number</p>
                  <h3 class="fw-bold">
                    **** **** **** {{ account.AccountNumber | maskNumber }}
                  </h3>
                </div>
                <div class="group">
                  <!-- <p class="text-muted m-0">Available Balance</p>
                  <h3 class="fw-bold">₦ 46,675.00</h3> -->
                </div>
                <div class="mt-4">
                  <div class="row align-items-center">
                    <div class="col-sm-12 col-md-6">
                      <!-- <p class="text-primary fw-bold">Block the card</p> -->
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-sm-12 col-md-4">
                <div class="mt-3">
                  <CurrentAccountBalance />
                </div>
              </div>
            </div>

            <div class="mt-4">
              <ul id="pills-tab" class="nav nav-pills mb-3" role="tablist">
                <li class="nav-item" role="presentation">
                  <button
                    id="pills-deposit-tab"
                    class="nav-link active"
                    data-bs-toggle="pill"
                    data-bs-target="#pills-deposit"
                    type="button"
                    role="tab"
                    aria-controls="pills-deposit"
                    aria-selected="true"
                  >
                    Withdraw
                  </button>
                </li>
              </ul>
              <div id="pills-tabContent" class="tab-content">
                <div
                  id="pills-deposit"
                  class="tab-pane fade show active"
                  role="tabpanel"
                  aria-labelledby="pills-deposit-tab"
                >
                  <div v-if="currentStep === 1" class="step-1">
                    <form @submit.prevent="submitForm">
                      <div class="py-5 px-2">
                        <p class="fw-bold">Enter Withrawal Details</p>
                        <p>Select the Customer's account to Withdraw from</p>
                        <div class="pin-input-container mt-3">
                          <p class="text-muted fw-bold">Customer's Account</p>
                          <input
                            id="formaccount"
                            v-model="form.accountToDebit"
                            v-validate="'required|decimal'"
                            type="text"
                            class="form-control"
                            placeholder="Account Number"
                            name="account"
                            @input="fetchBeneficiaryName()"
                          />
                          <div
                            v-show="verrors.has('account')"
                            class="invalid-feedback"
                          >
                            {{ verrors.first('account') }}
                          </div>
                        </div>
                        <div class="pin-input-container mt-2">
                          <label class="mb-2">Beneficiary Name:</label>
                          <input
                            v-model="form.beneficiaryName"
                            v-validate="'required'"
                            type="text"
                            class="form-control fw-bold"
                            name="Beneficiary Name"
                            disabled
                          />
                          <div
                            v-show="verrors.has('Beneficiary Name')"
                            class="invalid-feedback"
                          >
                            {{ verrors.first('Beneficiary Name') }}
                          </div>
                        </div>
                        <div class="pin-input-container mt-3">
                          <p class="text-muted fw-bold">Amount</p>
                          <input
                            id="formamount"
                            v-model="form.amount"
                            v-validate="'required|integer'"
                            currency="NGN"
                            type="text"
                            class="form-control"
                            placeholder="Amount"
                            name="amount"
                          />
                          <div
                            v-show="verrors.has('amount')"
                            class="invalid-feedback"
                          >
                            {{ verrors.first('amount') }}
                          </div>
                        </div>
                        <div class="mt-3">
                          <vs-button
                            :loading="form.active"
                            type="submit"
                            class="px-5"
                          >
                            Submit
                          </vs-button>
                          <!-- <button
                            type="submit"
                            class="btn btn-primary h6 float-end px-4"
                          >
                            Submit
                          </button> -->
                        </div>
                      </div>
                    </form>
                  </div>
                  <div v-if="currentStep === 2" class="step-2">
                    <form @submit.prevent="verifyOTP">
                      <div class="py-5 px-2">
                        <p class="fw-bold">Verify OTP</p>
                        <p>Enter OTP details</p>
                        <div class="pin-input-container mt-3">
                          <p class="text-muted fw-bold">OTP</p>
                          <input
                            id="formOTP"
                            v-model="form.otp"
                            v-validate="'required|integer'"
                            type="text"
                            class="form-control"
                            placeholder="OTP"
                            name="OTP"
                          />
                          <div
                            v-show="verrors.has('OTP')"
                            class="invalid-feedback"
                          >
                            {{ verrors.first('OTP') }}
                          </div>
                        </div>
                        <div class="mt-3">
                          <vs-button
                            :loading="form.active"
                            type="submit"
                            class="px-5"
                          >
                            Submit
                          </vs-button>
                          <!-- <button
                            type="submit"
                            class="btn btn-primary h6 float-end px-4"
                          >
                            Submit
                          </button> -->
                        </div>
                      </div>
                    </form>
                  </div>
                  <div v-if="currentStep === 3" class="step-2">
                    <form @submit.prevent="agentWithdrawal">
                      <div class="py-5 px-2">
                        <p class="fw-bold">Verify Withrawal Details</p>
                        <p>Enter transaction details</p>
                        <div class="pin-input-container mt-3">
                          <p class="text-muted fw-bold">Transaction Pin</p>
                          <input
                            id="formaccount"
                            v-model="form.transactionPin"
                            v-validate="'required|integer'"
                            type="text"
                            class="form-control"
                            placeholder="Transaction Pin"
                            name="Transaction Pin"
                          />
                          <div
                            v-show="verrors.has('Transaction Pin')"
                            class="invalid-feedback"
                          >
                            {{ verrors.first('Transaction Pin') }}
                          </div>
                        </div>
                        <div class="mt-3">
                          <vs-button
                            :loading="form.active"
                            type="submit"
                            class="px-5"
                          >
                            Submit
                          </vs-button>
                          <!-- <button
                            type="submit"
                            class="btn btn-primary h6 float-end px-4"
                          >
                            Submit
                          </button> -->
                        </div>
                      </div>
                    </form>
                  </div>
                </div>
                <div
                  id="pills-lock-card-pin"
                  class="tab-pane fade"
                  role="tabpanel"
                  aria-labelledby="pills-lock-card-pin-tab"
                >
                  ...
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Modal -->
    <!-- Successful Modal -->
    <div
      id="PaymentSuccessModal"
      class="modal fade"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Transaction Successful!</h3>

              <p class="text-muted my-2 px-3">Successful</p>

              <div class="mt-3">
                <div class="d-flex justify-content-between">
                  <vs-button
                    square
                    warn
                    gradient
                    size="large"
                    class="w-100"
                    @click="redirectToANewTab(recieptLink)"
                  >
                    Download Receipts
                  </vs-button>
                  <vs-button
                    square
                    icon
                    color="rgb(59,222,200)"
                    gradient
                    size="large"
                    class="w-100 mt-2"
                    @click="shareViaEmail()"
                  >
                    Share Via Mail
                  </vs-button>
                </div>
              </div>

              <div class="mt-3">
                <div class="d-flex justify-content-center">
                  <button
                    class="btn btn-primary btn-lg rounded-1 px-5 h6"
                    type="button"
                    style="font-size: 14px"
                    @click="redirectToAgentPage()"
                  >
                    <span class="px-2"> OK </span>
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  components: {},
  layout: 'dashboard',
  data: () => ({
    currentStep: 1,
    count: {},
    form: {
      code: '',
      newCode: '',
      account: '',
      active: false,
      beneficiaryName: '',
    },
    account: {},
    withdrawalToken: '',
    downloadRecieptModal: false,
    recieptLink: '',
  }),
  mounted() {
    this.fetchAccountData()
  },
  methods: {
    redirectToAgentPage() {
      window.location = '/user/dashboard/agency-banking'
    },
    async fetchAccountData() {
      const loading = this.$vs.loading({
        target: this.$refs.content,
        color: 'primary',
        scale: 2,
      })
      try {
        this.contentLoading = true
        const { payload } = await this.$axios.$get('/user/first-account')
        loading.close()
        this.account = payload
        this.contentLoading = false
      } catch (error) {
        loading.close()
        this.contentLoading = false
      }
    },
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          // console.log(this.form)

          this.form.active = true
          const data = {
            ...this.form,
          }
          this.$axios
            .$post('/agent/initialize-withdrawal', data)
            .then((response) => {
              this.form.active = false
              this.currentStep = 2
              this.openNotification('top-left', 'success', response.message)
              // console.log(response)
              this.withdrawalToken = response.payload.withdrawalToken
            })
            .catch((error) => {
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    agentWithdrawal() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          // console.log(this.form)

          this.form.active = true
          const data = {
            withdrawalToken: this.withdrawalToken,
            transactionPin: this.form.transactionPin,
          }
          this.$axios
            .$post('/agent/withdrawal', data)
            .then((response) => {
              this.recieptLink = response.payload.receipt
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('PaymentSuccessModal'),
                {}
              )
              modal.show()

              this.form.active = false
              // this.currentStep = 3
              this.openNotification('top-left', 'success', response.message)
            })
            .catch((error) => {
              console.log(error)
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    verifyOTP() {
      this.$validator.validateAll().then((result) => {
        if (result) {
          // console.log(this.form)

          this.form.active = true
          const data = {
            otp: this.form.otp,
          }
          this.$axios
            .$post('/agent/verify/withdrawal/otp', data)
            .then((response) => {
              this.form.active = false
              // this.currentStep = 3
              this.currentStep = 3
              this.openNotification('top-left', 'success', response.message)
              console.log(response)
            })
            .catch((error) => {
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    fetchBeneficiaryName() {
      this.form.beneficiaryName = ''
      if (this.form.accountToDebit && this.form.accountToDebit.length >= 10) {
        const data = {
          accountNumber: this.form.accountToDebit,
        }
        this.form.active = true
        this.$axios
          .$get(`/user/resolve-corestep-account/${data.accountNumber}`)
          .then((response) => {
            // console.log(response)
            this.openNotification('top-left', 'success', response.message)

            this.form.active = false
            this.form.beneficiaryName = response.payload.AccountName
          })
          .catch((error) => {
            console.log(error)
            this.form.active = false
            this.form.beneficiaryName = ''
            if (
              error.response.status === 404 ||
              error.response.status === 400 ||
              error.response.status === 401 ||
              error.response.status === 403 ||
              error.response.status === 406
            ) {
              // console.log(error.response.data.message)
              this.openNotification(
                'top-left',
                'danger',
                error.response.data.message
              )
            } else {
              this.openNotification(
                'top-left',
                'danger',
                error.response.data.message
              )
            }
          })
      }
    },
    redirectToANewTab(link) {
      window.open(link, '_blank')
    },
    shareViaEmail() {
      window.open(
        `mailto:?subject= I want to share this reciept with you &body= Hi there, Check out this reciept ${this.recieptLink}. Thanks.`,
        '_blank'
      )
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-agency-banking-page {
  .choose-transfer-type-card,
  .fill-beneficiary-details {
    background: #ffffff;
    border-radius: 20px;

    input.form-control,
    .form-select,
    textarea.form-control {
      background-color: #f4f2ec;
      border-radius: 5px;
      border: none;
    }
  }
}
</style>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-page-container {
  .choose-transfer-type-card,
  .fill-beneficiary-details {
    background: #ffffff;
    border-radius: 20px;

    input.form-control,
    .form-select,
    textarea.form-control {
      background-color: #f4f2ec;
      border-radius: 5px;
      border: none;
    }
  }
  .card-setting .nav-link {
    border: none;
    color: #000;
    font-weight: bold;
    background: none;
    border-radius: 0;
    margin: 0 5px;
    &.active {
      border-bottom: 3px solid $primary;
      color: #000;
      font-weight: bold;
      background: none;
      border-radius: 0;
    }
  }
}
.vue-pincode-input,
input.form-control {
  max-width: 245px !important;
  height: 50px;
  left: 468px;
  top: 729px;
  background: #f0f2f2;
  /* opacity: 0.08; */
  border-radius: 10px !important;
  box-shadow: none !important;
}
</style>
